unit CommProcess;

interface

uses
  Windows, Messages, SysUtils, Classes, Math;

const
	BUFFER_SIZE = 1024;				//ǂݍݑ҂󂯎Ɏgpobt@̑傫
	WAIT_FOR_RUN = 100;				//KɊԊuu߂ WaitForObjectƂSleep̑҂
//	CRLF = #13#10;					//sR[h
type
	TCharBuffer = array[0..BUFFER_SIZE-1] of Char;	//ǂݍݑ҂󂯎̃obt@
	TProcessPriority = ( ppIdle, ppNormal, ppHigh, ppRealTime );	//vZX̗̂Dx
	TLFChar = ( CRLF, LF, CR, LFLF, LFCR );							//sR[hZbg
const
	ProcessPriorities: array [TProcessPriority] of DWORD =
	   (IDLE_PRIORITY_CLASS,NORMAL_PRIORITY_CLASS,HIGH_PRIORITY_CLASS,REALTIME_PRIORITY_CLASS);
												//vZX̗DxvpeB̂Ɏgp
	LFChars: array[TLFChar] of string = ( #13#10, #10, #13, #10#10, #10#13 );
												//sR[hZbgvpeBɂ̂Ɏgp
type
	TCommProcess = class;
	TProcessThread = class;

	TProcessError = (peSecurity, peCreatePipe, peStartProcess,
						peTerminateProcess);	//G[̃CxgʒmɎgp(ꕔ)
	TProcessEvent = procedure(const Director: TCommProcess) of object;
												//CxgŎgp
	TProcessGetText = procedure(const ProcessID:DWORD; const Text:string ) of object;
												//炩̃eLXg󂯎p
	TProcessErrorEvent = procedure(
						const Director:TCommProcess; const ProcessError: TProcessError) of object;
												//G[
	TProcessExitEvent = procedure(
						const Director:TCommProcess; const ExitCode: Integer) of object;
												//I

TCommProcess = class(TComponent)
  private
	{ Private 錾 }
	  FhProcess						:THandle;	//vZX̃nh
	  FdwProcessID					:DWORD;		//vZXID
	  FCommandLine, FOption			:string;	//st@C̃pXƒǉIvV
	  FProcessPriority				:DWORD;		//vZX̗̂Dx̎
	  FThreadPriority				:TThreadPriority;	//҂󂯃Xbh̗Dx
	  FisRunning					:Boolean;			//sۂ dɎsȂ悤ɂ
	  FExitCode						:DWORD;	   	//vZX̏IR[h

	  FOnExecute					:TProcessEvent;
	  FOnExit						:TProcessExitEvent;
	  FOnError						:TProcessErrorEvent;
	  FOnTerminate					:TProcessEvent;
	  FOnGetStdOut					:TProcessGetText;
	  FOnGetErrOut					:TProcessGetText;

	  FhStdOutRead, FhErrOutRead	:THandle;
	  FhStdInWrite					:THandle;
	  FStdOutList, FErrOutList		:TStrings;
	  FProcessThread				:TProcessThread;

	  FsLineFeedChar				:string;

	  procedure EndThread( Sendor:TObject );

	  procedure SetProcessPriority( pp:TProcessPriority );
	  function GetProcessPriority(): TProcessPriority;

	  procedure SetLineFeedChar( lfc:TLFChar );
	  function GetLineFeedChar(): TLFChar;

	  function StartProcessInstance() :Boolean;

	  procedure DoError( pe :TProcessError );
	  procedure DoExecute();
	  procedure DoExit();

  protected
    { Protected 錾 }
  public
	{ Public 錾 }
	constructor Create( AOwner:TComponent ); override;
	destructor Destroy(); override;

	procedure SetStdOutStrings( AStdStrings:TStrings );
	procedure SetErrOutStrings( AErrStrings:TStrings );
	procedure SetOutputStrings( AStdStrings, AErrStrings:TStrings );

	function StartProcess() :Boolean;
	function SendCommand( Command:string ) :Boolean;
	procedure KillProcess();

  published
	{ Published 錾 }
	property CommandLine	:string read FCommandLine write FCommandLine;
	property Option			:string read FOption write FOption;
	property ProcessPriority	:TProcessPriority read GetProcessPriority write SetProcessPriority;
	property ThreadPriority	:TThreadPriority read FThreadPriority write FThreadPriority;

	property LineFeedChar	:TLFChar read GetLineFeedChar write SetLineFeedChar;

	property IsRunning		:Boolean read FisRunning;
	property dwProcessID	:DWORD read FdwProcessID;
	property hProcess		:THandle read FhProcess;

	property OnExecute		:TProcessEvent read FOnExecute write FOnExecute;
	property OnExit			:TProcessExitEvent read FOnExit write FOnExit;
	property OnError		:TProcessErrorEvent read FOnError write FOnError;
	property OnTerminate	:TProcessEvent read FOnTerminate write FOnTerminate;
	property OnGetStdOut	:TProcessGetText read FOnGetStdOut write FOnGetStdOut;
	property OnGetErrOut	:TProcessGetText read FOnGetErrOut write FOnGetErrOut;

end;


TProcessThread = class(TThread)
  private
	{ Private 錾 }
	FDirector	:TCommProcess;
	FStdOutLine	:string;
	FErrOutLine	:string;
	FStdInList 	:TStringList;

	procedure AppendStdOut();
	procedure AppendErrOut();
	procedure WriteStdIn();

  protected
	procedure Execute; override;
  public
	constructor Create( ADirector:TCommProcess );
	destructor Destroy(); override;
	procedure SetStdInLine( str:string );
end;



procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Test', [TCommProcess]);
end;

////////////////////////////////////////////////////////////////////////////////
// TProcessThread
////////////////////////////////////////////////////////////////////////////////
{:
  قȂXbhL VCL ܂ CLX ̃\bh/֐/
  vpeBʂ̃Xbh̒爵ꍇAr̖肪
  ܂B

  CXbh̏LIuWFNgɑ΂Ă Synchronize
  \bhgł܂B̃IuWFNgQƂ邽
  ̃\bhXbhNXɒǉASynchronize \bh
  Ƃēn܂B

  Ƃ΁AUpdateCaption \bhȉ̂悤ɒ`A

    procedure TProcessThread.UpdateCaption;
    begin
      Form1.Caption := 'TProcessThread Xbh珑܂';
    end;

  Execute \bh̒ Synchronize \bhɓnƂŃC
  XbhL Form1  Caption vpeBSɕ
  Xł܂B

      Synchronize(UpdateCaption);
}

{ TProcessThread }

constructor TProcessThread.Create( ADirector:TCommProcess );
begin
	inherited Create( True );
	FreeOnTerminate := False;
	FDirector := ADirector;
	Priority := ADirector.FThreadPriority;
	OnTerminate := ADirector.EndThread;
	FStdInList := TStringList.Create;
	Resume;
end;

destructor TProcessThread.Destroy();
begin
	FStdInList.Free;
	inherited Destroy;
end;

procedure TProcessThread.AppendStdOut();
begin
	if( Assigned( FDirector.FStdOutList ) ) then
	begin
		FDirector.FStdOutList.Append( FStdOutLine );
	end;
	if( Assigned( FDirector.FOnGetStdOut ) ) then
	begin
		FDirector.FOnGetStdOut( FDirector.FdwProcessID, FStdOutLine );
	end;
	FStdOutLine := '';
end;

procedure TProcessThread.AppendErrOut();
begin
	if( Assigned( FDirector.FErrOutList ) ) then
	begin
		FDirector.FErrOutList.Append( FErrOutLine );
	end;
	if( Assigned( FDirector.FOnGetErrOut ) ) then
	begin
		FDirector.FOnGetErrOut( FDirector.FdwProcessID, FErrOutLine );
	end;
	FErrOutLine := '';
end;

procedure TProcessThread.WriteStdIn();
var
	i			:integer;
	c			:DWORD;
	command		:string;
	pBuffer		:^TCharBuffer;
begin
	pBuffer := AllocMem( BUFFER_SIZE );
	while( FStdInList.Count > 0 ) do
	begin
		command := FStdInList.Strings[0] + #13#10(*CRLF*);
		ReAllocMem( pBuffer, Length(command)+1 );
		ZeroMemory( pBuffer, Length(command)+1 );
		for i := 0 to length(command)-1 do
			pBuffer^[i] := command[i+1];
		if( not(WriteFile( FDirector.FhStdInWrite, pBuffer^, Length(command), c, nil ) )
			or ( c<> DWORD(Length(command)) ) ) then
		begin
		end;
		FStdInList.Delete(0);
	end;
	FreeMem( pBuffer );
end;

procedure TProcessThread.Execute;
var
	dwRet, dwExitCode		:DWORD;
	dwStdRead, dwStdAvail	:DWORD;
	dwErrRead, dwErrAvail	:DWORD;
	buf						:string;
	lnStd, lnErr			:string;
	i						:integer;
begin
{ ToDo : XbhƂĎsR[h̉ɋLqĂ }
	lnStd := '';
	lnErr := '';

	repeat
		GetExitCodeProcess( FDirector.FhProcess, dwExitCode );

		//W͂̏
		Synchronize(WriteStdIn);

		//Wo͂̓ǂݎ
		dwStdAvail := 0;
		PeekNamedPipe( FDirector.FhStdOutRead, nil, 0, nil, @dwStdAvail, nil );
		if( dwStdAvail<> 0 )	then
		begin
			buf := '';
			SetLength( buf, Min(BUFFER_SIZE-1,dwStdAvail) );
			dwStdRead := 0;
			if( not ReadFile( FDirector.FhStdOutRead,
					PChar(buf)^,
					min( BUFFER_SIZE-1, dwStdAvail ),
					dwStdRead,
					nil ) ) then
			begin
				Exit;
			end;
			if( dwStdRead<>0 ) then
			begin
				SetLength( buf, dwStdRead );
				lnStd := lnStd + buf;
				i := AnsiPos( FDirector.FsLineFeedChar, lnStd );
				while( i > 0 ) do
				begin
					FStdOutLine := Copy( lnStd, 1, i-1 );
					Synchronize(AppendStdOut);
					Delete( lnStd, 1, i-1+length(FDirector.FsLineFeedChar) );
					i := AnsiPos( FDirector.FsLineFeedChar, lnStd );
				end;
			end;
		end;

		//G[o͂̓ǂݎ
		dwErrAvail := 0;
		PeekNamedPipe( FDirector.FhErrOutRead, nil, 0, nil, @dwErrAvail, nil );
		if( dwErrAvail<> 0 )	then
		begin
			buf := '';
			SetLength( buf, Min(BUFFER_SIZE-1,dwErrAvail) );
			dwErrRead := 0;
			if( not ReadFile( FDirector.FhErrOutRead,
					PChar(buf)^,
					min( BUFFER_SIZE-1, dwErrAvail ),
					dwErrRead,
					nil ) ) then
			begin
				Exit;
			end;
			if( dwErrRead<>0 ) then
			begin
				SetLength( buf, dwErrRead );
				lnErr := lnErr + buf;
				i := AnsiPos( FDirector.FsLineFeedChar, lnErr );
				while( i > 0 ) do
				begin
					FErrOutLine := Copy( lnErr, 1, i-1 );
					Synchronize(AppendErrOut);
					Delete( lnErr, 1, i-1+length(FDirector.FsLineFeedChar) );
					i := AnsiPos( FDirector.FsLineFeedChar, lnErr );
				end;
			end;
		end;

		if( Terminated ) then
			TerminateProcess( FDirector.FhProcess, 0 );
		dwRet := WaitForSingleObject( FDirector.FhProcess, WAIT_FOR_RUN );
		Sleep( WAIT_FOR_RUN );

	until( (dwExitCode<>STILL_ACTIVE) or (dwRet<>WAIT_TIMEOUT) );

	if( lnStd <> '' ) then
	begin
		FStdOutLine := lnStd;
		Synchronize(AppendStdOut);
	end;
	if( lnErr <> '' ) then
	begin
		FErrOutLine := lnErr;
		Synchronize(AppendErrOut);
	end;
end;

procedure TProcessThread.SetStdInLine( str:string );
begin
	FStdInList.Append( str );
end;



////////////////////////////////////////////////////////////////////////////////
// TCommProcess
////////////////////////////////////////////////////////////////////////////////
constructor TCommProcess.Create( AOwner:TComponent );
begin
	inherited Create( AOwner );					//p̃RXgN^
	FisRunning := False;						//܂sĂȂ
	FThreadPriority := tpNormal;                //ftHg̃XbhDx
	FProcessPriority := NORMAL_PRIORITY_CLASS;	//ftHg̃vZXDx
	FsLineFeedChar := #13#10;					//ftHg̋؂蕶(CRLFɑ)
end;

destructor TCommProcess.Destroy();
var
	dwRet		:DWORD;
begin
	if( FisRunning ) then
	begin
		GetExitCodeProcess( FhProcess, dwRet );
		if( DwRet = STILL_ACTIVE ) then
			TerminateProcess( FhProcess, 0 );
			FProcessThread.WaitFor;
//		CloseHandle( FhProcess );
//  	CloseHandle( FhStdOutRead );
//		CloseHandle( FhErrOutRead );
//		CloseHandle( FhStdInWrite );
		FProcessThread.Free;
	end;
	inherited Destroy;
end;

procedure TCommProcess.SetProcessPriority( pp:TProcessPriority );
begin
	FProcessPriority := ProcessPriorities[pp];
end;

function TCommProcess.GetProcessPriority():TProcessPriority;
var
	i	:TProcessPriority;
begin
	Result := ppNormal;
	for i := Low(TProcessPriority) to High(TProcessPriority) do
		if( ProcessPriorities[i] = FProcessPriority ) then Result := i;
end;

procedure TCommProcess.SetLineFeedChar( lfc:TLFChar );
begin
	FsLineFeedChar := LFChars[lfc];
end;

function TCommProcess.GetLineFeedChar() :TLFChar;
var
	i	:TLFChar;
begin
	Result := CRLF;
	for i := Low(TLFChar) to High(TLfChar) do
		if( LFChars[i] = FsLineFeedChar ) then Result := i;
end;

procedure TCommProcess.SetStdOutStrings( AStdStrings:TStrings );
begin
	FStdOutList := AStdStrings;
end;

procedure TCommProcess.SetErrOutStrings( AErrStrings:TStrings );
begin
	FErrOutList := AErrStrings;
end;

procedure TCommProcess.SetOutputStrings( AstdStrings, AErrStrings:TStrings );
begin
	SetStdOutStrings( AStdStrings );
	SetErrOutStrings( AErrStrings );
end;

procedure TCommProcess.DoExecute();
begin
	if( Assigned( FOnExecute ) ) then
	begin
		FOnExecute( Self );
	end;
end;

procedure TCommProcess.DoError( pe:TProcessError );
begin
	if( Assigned( FOnError ) ) then
	begin
		FOnError( Self, pe );
	end;
end;

procedure TCommProcess.DoExit();
begin
	if( Assigned( FOnExit ) ) then
	begin
		FOnExit( Self, FExitCode );
	end;
end;

function TCommProcess.StartProcess() :Boolean;
begin
	DoExecute;

	if( not StartProcessInstance ) then
	begin
		Result := False;
		Exit;
	end;
	FProcessThread := TProcessThread.Create(Self);
	Result := True;
end;

function TCommProcess.StartProcessInstance() :Boolean;
//pCv̏Ƃ qvZX̏ƂqvZX̎sƂ
var
	hStdOutWrite, hStdOutRead	:THandle;
	hErrOutWrite, hErrOutRead	:THandle;
	hStdInWrite, hStdInRead		:THandle;
	sa							:TSecurityAttributes;
	si							:TStartupInfo;
	processinfo					:TProcessInformation;
	CommandLine					:string;
	dwRet						:DWORD;
begin
	Result := False;
	if( FisRunning ) then
		Exit;

	//pCv쐬pSecurityAttribute
	sa.nLength := sizeof( TSecurityAttributes );
	sa.lpSecurityDescriptor := nil;
	sa.bInheritHandle := True;

	//Wo͗p̃pCv쐬
	if( not CreatePipe( hStdOutRead, hStdOutWrite, @sa, BUFFER_SIZE ) ) then
	begin
		DoError( peCreatePipe );
		Exit;
	end;
	DuplicateHandle( GetCurrentProcess, hStdOutRead, GetCurrentProcess, @FhStdOutRead,
		0, False(*pȂ*), DUPLICATE_SAME_ACCESS );
	CloseHandle( hStdOutRead );

	//G[o͗p̃pCv쐬
	if( not CreatePipe( hErrOutRead, hErrOutWrite, @sa, BUFFER_SIZE ) ) then
	begin
		DoError( peCreatePipe );
		Exit;
	end;
	DuplicateHandle( GetCurrentProcess, hErrOutRead, GetCurrentProcess, @FhErrOutRead,
		0, False(*pȂ*), DUPLICATE_SAME_ACCESS );
	CloseHandle( hErrOutRead );

	//W͗p̃pCv쐬
	if( not CreatePipe( hStdInRead, hStdInWrite, @sa, BUFFER_SIZE ) ) then
	begin
		DoError( peCreatePipe );
		Exit;
	end;
	DuplicateHandle( GetCurrentProcess, hStdInWrite, GetCurrentProcess, @FhStdInWrite,
		0, False(*pȂ*), DUPLICATE_SAME_ACCESS );
	CloseHandle( hStdInWrite );

	ZeroMemory( @si, sizeof(si) );
	si.cb := sizeof(si);
	si.dwFlags := STARTF_USESTDHANDLES or STARTF_USESHOWWINDOW;
	si.wShowWindow := SW_HIDE;
	si.hStdOutput := hStdOutWrite;
	si.hStdError := hErrOutWrite;
	si.hStdInput := hStdInRead;
	CommandLine := FCommandLine +' '+ FOption;

	try
		if( not CreateProcess( nil, PChar(CommandLine), nil, nil, True,
			FProcessPriority or CREATE_NEW_CONSOLE, nil, nil, si, processinfo ) ) then
		begin
			DoError( peStartProcess );
			Exit;
		end else
		begin
			CloseHandle( processinfo.hThread );
			FhProcess := processinfo.hProcess;
			FdwProcessID := processinfo.dwProcessId;
		end;
	finally
		CloseHandle( hStdOutWrite );
		CloseHandle( hErrOutWrite );
		CloseHandle( hStdInRead );
	end;

	dwRet := WaitForSingleObject( FhProcess, WAIT_FOR_RUN );
	if( dwRet = WAIT_OBJECT_0 ) then
	begin
		CloseHandle( FhProcess );
		FhProcess := 0;
		Exit;
	end;
	Result := True;	//I
	FisRunning := True;
end;

procedure TCommProcess.KillProcess();
begin
	if( (FisRunning) and Assigned(FProcessThread) ) then
	begin
		FProcessThread.Terminate;
		if( Assigned( FOnTerminate ) ) then
		begin
			FOnTerminate( Self );
		end;
	end;
end;

procedure TCommProcess.EndThread( Sendor:TObject );
begin
	GetExitCodeProcess( FhProcess, FExitCode );
	CloseHandle( FhProcess );
	CloseHandle( FhStdOutRead );
	CloseHandle( FhErrOutRead );
	CloseHandle( FhStdInWrite );
	Sendor.Free;
	FisRunning := False;
	DoExit;
end;

function TCommProcess.SendCommand( command:string ) :Boolean;
begin
	if( not FisRunning ) then
	begin
		Result := False;
		Exit;
	end;
	FProcessThread.SetStdInLine( command );
	Result := True;
end;

end.
